// MineSolver Matthias Grtner, Oktober 1992, Mai 1993
//
// Telefon/FAX: +49 721 / 691717
//
// Erstes Verfahren: direkter Schlu
//
// Dieses Programm ist FreeWare. Mein Name als Autor mu auch in
// abgeleiteten Versionen ersichtlich sein (z.B. in der About-Box).
//
// Es wrde mich freuen, von Vernderungen des Programms zu hren.
//
// Die Bestimmungen in der Datei MS.DOC sind zu beachten.

// Die so zahlreich nicht vorhandenen Kommentare bitte ich zu
// entschuldigen. Hoffentlich wird's auch so verstndlich.

// #define STRICT		// Diese DEFINES stehen beteits im Projekt
// #define WIN31		// und sind fr alle Dateien zu benutzen
// #define _CLASSDLL

#include	<windows.h>
#include	<owl.h>
#include	<bwcc.h>
#pragma hdrstop;

#define max(a,b) ((a)>(b) ? (a) : (b))
#define min(a,b) ((a)<(b) ? (a) : (b))

#define WIN_X_SIZE	200
#define	WIN_Y_SIZE	180

#define ID_SOLVE	100
#define ID_ABOUT	101
#define M1	110
#define F1	120
#define M2	111
#define F2	121


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

HWND	hSweepWindow = 0;
HDC		hSweepDC;

RECT	r;
int		xx,yy, xpos, ypos;

int		AroundX, AroundY;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

_CLASSDEF(Place)

class _CLASSTYPE Place
{
public:
			Place();
	void	Clear();

	WORD	ya, na;		// YesAround, NoAround
	WORD	wert;		// 0...8
	BOOL	sicher;		// TRUE/FALSE
	BOOL	bomb;
    BOOL	offBoard;
};

Place::Place()
{
	Clear();
}

void Place::Clear( void )
{
	ya = na = 0;
	wert = 0;
	bomb = FALSE;
	sicher = FALSE;
    offBoard = FALSE;
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

_CLASSDEF(MineField)

class _CLASSTYPE MineField
{
public:
	MineField();
	MineField( int );
	~MineField();

    void	Resize( int );

	RPlace	M( int, int );
    RPlace	Around( int, int, int );
	void	IncrNA( int, int );
	void	IncrYA( int, int );
	void	SetNoBomb( int, int );
	void	SetBomb( int, int );

	int		CountMines( void );
    int		CountFree( void );

	int		readPixels( void );
	int		getSpot( int, int );
	int		process1( void );

	PPlace	f;
	Place	dummy;

    int		size;
};

int MineField::process1( void )
{
	int erg = 0,x,y;

	for( x = 0; x < xx; x++ )
	{
		for( y = 0; y < yy; y++ )
		{
			RPlace	p = M(x,y);

			if( p.na > 8 )
			{
				erg = 2;
				return erg;
			}

			if( p.ya > 8 )
			{
            	erg = 3;
				return erg;
			}

			if( p.na+p.ya > 8 )
			{
				erg = 4;
				return erg;
			}

			if( p.sicher && !p.bomb && p.wert && p.na+p.ya < 8 )
            {
				if( p.ya == p.wert )
				{
					SetNoBomb( x,y );
					p.na = 8-p.ya;
					erg = 1;
				}
				else if( p.na == 8-p.wert )
				{
					SetBomb( x,y );
					p.ya = 8-p.na;
					erg = 1;
				}
            }
		}
    }
	return erg;
}

MineField::MineField()
{
	size = 0;
	dummy.offBoard = TRUE;
	f = NULL;
}

MineField::MineField( int sz )
{
	size = sz;
	dummy.offBoard = TRUE;
	f = new Place [ size ];
}

void MineField::Resize( int sz )
{
	if( sz > size )
	{
		if( f )
		{
			delete [] f;
        }
		size = sz;
		f = new Place [ size ];
	}
	size = sz;
}

MineField::~MineField()
{
	if( f )
	{
		delete [] f;
    }
}

RPlace	MineField::M( int x, int y)
{
	if( x < 0  || y < 0 || x >= xx || y >= yy )
	{
		return dummy;
	}
	else
	{ 
		return f[ y * xx + x ];
    }
}

RPlace MineField::Around( int x, int y, int n )
{
	static int	q[] =
		{
			 1,-1,		// 670
			 1,0,		// 5 1 
			 1,1,		// 432		
			 0,1,
			 -1,1,
			 -1,0,
			 -1,-1,
			 0,-1
		};

	n &= 7;
	n <<= 1;
	AroundX = x + q[n];
	AroundY = y + q[n+1];
	return M( AroundX, AroundY );
}

void MineField::IncrNA( int x, int y )
{
	if( x < 0  || y < 0 || x >= xx || y >= yy )
	{
		return;
    }

	for( int i = 0; i < 8; i++ )
	{
		RPlace p = Around(x,y,i);
        if( !p.offBoard && !p.bomb )
		{
			p.na++;
        }
	}
}

void MineField::IncrYA( int x, int y )
{
	if( x < 0  || y < 0 || x >= xx || y >= yy )
	{
		return;
    }

	for( int i = 0; i < 8; i++ )
	{
		RPlace p = Around(x,y,i);
		if( !p.offBoard && !p.bomb )
        {
			p.ya++;
        }
	}
}

void MineField::SetNoBomb( int x, int y )
{
	for( int i = 0; i < 8; i++ )
	{
		RPlace p = Around(x,y,i);
		if( !p.offBoard && !p.sicher )
		{
			p.sicher = TRUE;
			p.bomb   = FALSE;
			IncrNA( AroundX, AroundY );
		}
	}
}

void MineField::SetBomb( int x, int y )
{
	for( int i = 0; i < 8; i++ )
	{
		RPlace p = Around(x,y,i);
		if( !p.offBoard && !p.sicher )
		{
			p.sicher = TRUE;
			p.bomb   = TRUE;
			IncrYA( AroundX, AroundY );
		}
	}
}

int MineField::readPixels( void )
{
	int	x,y, unknown;

    unknown = FALSE;
	hSweepDC = GetDC( hSweepWindow );

	// Von Minesweeper die Belegung einlesen

	for( x = 0; x < xx; x++ )
	{
		for( y = 0; y < yy; y++ )
		{
			RPlace	p = M(x,y);

			p.Clear();

			int	i = getSpot( x,y );
			if( i == -1 )
			{
				p.bomb = TRUE;
				p.sicher = TRUE;
			}
			else if( i >= 0 )
			{
				p.wert = i;
				p.bomb = FALSE;
				p.sicher = TRUE;
			}
			else
			{
            	unknown = TRUE;
            }
		}
	}
	ReleaseDC( hSweepWindow, hSweepDC );

    // die Werte der Auenfelder werden korrigiert

	for( x = 0; x < xx; x++ ) { M(x,0).na += 3; M(x, yy-1).na += 3; }
	for( y = 0; y < yy; y++ ) { M(0,y).na += 3; M(xx-1, y).na += 3; }

    // Die Eckenfelder nochmal korrigeren

	M(0 ,     0).na -= 1;
	M(0 ,  yy-1).na -= 1;
	M(xx-1,   0).na -= 1;
	M(xx-1,yy-1).na -= 1;

	// Berechnen der ya,na-Werte der Feldelemente

	for( x = 0; x < xx; x++ )
	{
		for( y = 0; y < yy; y++ )
		{
			RPlace	p = M(x,y);
			if( p.sicher )
			{
				if( p.bomb )
				{
					IncrYA( x,y );
				}
				else
				{
					IncrNA( x,y );
				}
            }
		}
	}
    return unknown;
}

// liefert: -2: frei, -1 Bombe, 0...8 : Wert

int MineField::getSpot( int x, int y )
{
	static DWORD	farben[] =
		{	RGB(192,192,192),	// Bombe
			RGB(192,192,192),	// 0
			RGB(0,0,255),		// 1
			RGB(0,128,0),		// 2 ...
			RGB(255,0,0),
			RGB(0,0,128),
			RGB(128,0,0),
			RGB(0,128,128),
			RGB(0,0,0),
			RGB(128,128,128)
		};

	x <<= 4;
	x +=  21;
	y <<= 4;
	y +=  63;

	DWORD	 d = GetPixel( hSweepDC, x,y );
	DWORD	*p = farben;
	int		 i = -1 ;

	while( i < 8 )
	{
		if( *p == d )
		{
			if( i == -1 )	// zus. Test bei Bomben
			{
				d = GetPixel(hSweepDC, x-1,y);		// Schwarzer Pfosten ?
				if( d == RGB(0,0,0) )
				{
					break;
				}
				d = GetPixel(hSweepDC, x-8,y-7);	// Weier Rand: leer
				if( d == RGB(255,255,255) )
				{
                	i = 8;
                	break;
                }
				i++; p++;
			}
			else
            {
				break;
            }
		}
		else
		{
        	i++; p++;
        }
	}
	return( (i >= 8) ? -2 : i );
}

int	MineField::CountMines( void )
{
	int r = 0;
	for( int i = 0; i < size; i++ )
	{
    	if( f[i].sicher && f[i].bomb ) r++;
	}
	return r; 
}

int	MineField::CountFree( void )
{
	int r = 0;
	for( int i = 0; i < size; i++ )
	{
    	if( !f[i].sicher ) r++;
	}
	return r; 
}


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

_CLASSDEF(TMSWindow)

class TMSWindow : public TDialog // TWindow
{
public:
	TMSWindow( PTWindowsObject aParent, LPSTR aTitle );
	virtual void SetupWindow( void );
	virtual LPSTR GetClassName();
	virtual void GetWindowClass(WNDCLASS _FAR &);
//	virtual void WMGetMinMaxInfo(RTMessage) = [WM_FIRST + WM_GETMINMAXINFO];
//	virtual void Paint(HDC, PAINTSTRUCT _FAR & );

			int  CheckGO( void );

	
	virtual void MenuSolve(RTMessage) = [ID_FIRST+ID_SOLVE];	// TWindow: CM_
	virtual void MenuAbout(RTMessage) = [ID_FIRST+ID_ABOUT];
//	virtual void MenuRepaint(RTMessage) = [CM_FIRST+ID_REPAINT ];

	HWND		FindMineSweeper( void );
    void		FillStatus( void );

    PMineField	Field;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


// Geht die Liste der Fenster durch und sucht nach dem Minesweeper-Fenster
// Erfolg: Handle, sonst 0

HWND TMSWindow::FindMineSweeper( void )
{
	char	classname[50];
    int		e = 0;
	HWND	h = GetWindow( HWindow, GW_HWNDFIRST );

	while( h != NULL ) {
		if( ::GetClassName( h, classname, 50) == 11 &&
			lstrcmp(classname,"Minesweeper") == 0 )
		{
			// Fenster gefunden
            break;
		}
		else
		{
			h = GetWindow( h, GW_HWNDNEXT );
		}
	}
	if( h )
	{
    	e = 1;
		GetClientRect( h, &r );

		xx = r.right - r.left;
		yy = r.bottom - r.top;

		if( xx != 0 && yy != 0 )
        {
			xx = (xx - 16) >> 4;
			yy = (yy - 62) >> 4;

			Field->Resize( xx * yy );

			if( Field->readPixels() == 0 )
			{
				BWCCMessageBox( HWindow, "Das Spiel scheint\ngelst zu sein !",
					"Nix zu tun...", MB_ICONEXCLAMATION | IDOK );
				h = 0;
			}
		}
		else
		{
			h = 0;
            e = 0;
        }
	}
    if( !e )
	{
		BWCCMessageBox( HWindow, "Es ist wohl kein MineSweeper geladen !",
			"Fehler...", MB_ICONSTOP | IDOK );
	}
    hSweepWindow = h;
	return h;
}

void	TMSWindow::FillStatus( void )
{
	int		m = Field->CountMines();
	int		f = Field->CountFree();
	int		t = Field->size;

	char	tmp[30];

	wsprintf( tmp, "%u", m );
	SetDlgItemText( HWindow, M1, tmp );
	 
	wsprintf( tmp, "%u/%u", f, t-f );
	SetDlgItemText( HWindow, F1, tmp );

	long l = f;
	l *= 100;
	if( t != 0 ) l /= t; else l = 0;

	t = (int) l;	 
	wsprintf( tmp, "%u%%", t );
	SetDlgItemText( HWindow, F2, tmp );
	 
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

TMSWindow::TMSWindow( PTWindowsObject aParent, LPSTR aTitle ) :
//	TWindow( aParent, aTitle )
	TDialog( aParent, aTitle )
{
//	DisableAutoCreate();
//	Attr.Style = WS_OVERLAPPEDWINDOW;
//	Attr.W = WIN_X_SIZE;
//	Attr.H = WIN_Y_SIZE;
//	AssignMenu("MSMENU");

	Field = new MineField();
}

void TMSWindow::SetupWindow()
{
//	TWindow::SetupWindow();
	TDialog::SetupWindow();
	xx = 0;

	FindMineSweeper();

    FillStatus();
}

LPSTR TMSWindow::GetClassName()
{
  return "MineSolver";
}

void TMSWindow::GetWindowClass(WNDCLASS _FAR & AWndClass)
{
//	TWindow::GetWindowClass(AWndClass);
	TDialog::GetWindowClass(AWndClass);
	AWndClass.hIcon = LoadIcon(GetApplication()->hInstance, "MS");
}

/*
void TMSWindow::WMSize(RTMessage msg)
{
	TWindow::WMSize(msg);
}
*/

/*
void TMSWindow::WMGetMinMaxInfo(RTMessage msg)
{

	POINT   _FAR *p = (POINT _FAR *) msg.LParam;

	p[1].x = min(WIN_X_SIZE, p[1].x);
	p[1].y = min(WIN_Y_SIZE, p[1].y);
	p[3].x = max(WIN_X_SIZE, p[3].x);
	p[3].y = max(WIN_Y_SIZE, p[3].y);
	p[4].x = min(WIN_X_SIZE, p[4].x);
	p[4].y = min(WIN_Y_SIZE, p[4].y);
}
*/

/*
void TMSWindow::Paint(HDC hDC, PAINTSTRUCT _FAR & )
{
	int		x, y;
	char	tmp[2];

    tmp[1] = 0;
	for( x = 0; x < xx; x++ )
	{
		for( y = 0; y < yy; y++ )
		{
			RPlace p = Field->M(x,y);
			if( p.sicher )
            {
				if( p.bomb )
				{
                	tmp[0] = 'B';
				}
				else
				{
					tmp[0] = '0' + p.wert;
				} 
			}
			else
			{
				tmp[0] = '?';
			} 
			TextOut( hDC, x * 14, y * 14, tmp, 1 );
        }
    }
}
*/

int TMSWindow::CheckGO( void )
{
	DWORD	d;

	hSweepDC = GetWindowDC( hSweepWindow );
	d = GetPixel( hSweepDC, 9+xx*8,63 );
	ReleaseDC( hSweepWindow, hSweepDC );

	return( d == RGB(0,0,0) );
}

/*
void TMSWindow::MenuRepaint(RTMessage)
{
	if( FindMineSweeper() )
	{
		InvalidateRect( HWindow, NULL, TRUE );
		UpdateWindow( HWindow );
    }
}
*/

void TMSWindow::MenuAbout(RTMessage)
{
	GetModule()->ExecDialog( new TDialog( this, "MSABOUT" ) );
//	MessageBeep( 0 );
}

void TMSWindow::MenuSolve(RTMessage)
{
	int		x,y, i, j;
	BOOL	again;
	BOOL	*p;

	if( !FindMineSweeper() )
	{
		return;
	}

	p = new BOOL [ Field->size ];
	do {

		j = 0;

		if( CheckGO() )
		{
			delete [] p;
			MessageBox( HWindow, "GAME OVER", "Ouch...", MB_ICONEXCLAMATION | MB_OK );
			return;
		}

		Field->readPixels();

		// Feld kopieren
		for( i = 0; i < Field->size; i++ )
		{
			p[i] = Field->f[i].sicher;
		}

		do {
			i = Field->process1();
			if( i == 2 )
			{
				BWCCMessageBox( HWindow, "NA-Fehler",
				"Konsistenzfehler...", MB_ICONSTOP | IDOK );
			}

			if( i == 3 )
			{
				BWCCMessageBox( HWindow, "YA-Fehler",
				"Konsistenzfehler...", MB_ICONSTOP | IDOK );
			}

			if( i == 4 )
			{
				BWCCMessageBox( HWindow, "NA+YA-Fehler",
				"Konsistenzfehler...", MB_ICONSTOP | IDOK );
			}
			if( i >= 2 )
			{
				j = 0;
				i = 0;
            }

			if( i )
			{
				j = 1;
			}

		} while( 0 /*i*/ );

		again = FALSE;

		if( j != 0 )
		{
			// Kopie mit dem Original vergleichen (im Feld 'sicher') und evtl.
			// Botschaften an Minesweeper schicken.

			for( x = 0; x < xx; x++ )
			{
				for( y = 0; y < yy; y++ )
				{
					i = y * xx + x;
					if( !p[i] && Field->M(x,y).sicher )
					{
						BOOL	b = (Field->M(x,y).bomb);
						WORD wMsg1 = b ? WM_RBUTTONDOWN : WM_LBUTTONDOWN;
						WORD wMsg2 = b ? WM_RBUTTONUP   : WM_LBUTTONUP;
						WORD wPara = b ? MK_RBUTTON     : MK_LBUTTON;

						SendMessage( hSweepWindow, wMsg1,wPara,MAKELONG((x<<4)+21,(y<<4)+63 ) );
						SendMessage( hSweepWindow, wMsg2,wPara,MAKELONG((x<<4)+21,(y<<4)+63 ) );
                        again = TRUE;
					}
				}
			}
		}

		FillStatus();

		if( !again || j == 0 )
        {
//			MessageBox( HWindow, "Leider nix gefunden...", "Sorry",
//				MB_ICONEXCLAMATION | MB_OK );

			MessageBeep( 0 );

		}
	} while( again );

    FillStatus();

	delete [] p;
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

class TWGALApp : public TApplication
{
public:
    TWGALApp( LPSTR name, HINSTANCE hInstance,
		  HINSTANCE hPrevInstance, LPSTR lpCmd,
          int nCmdShow)
            : TApplication(name, hInstance,
				   hPrevInstance, lpCmd, nCmdShow) {};
	virtual void InitMainWindow( void );
	virtual void InitInstance( void );
};

void TWGALApp::InitMainWindow( void )
{

//	MainWindow = new TMSWindow( NULL, Name );

	MainWindow = new TMSWindow(NULL, "MSDIALOG");

	ExecDialog( MainWindow );
}

void TWGALApp::InitInstance( void )
{
	TApplication::InitInstance();
	BWCCGetVersion();
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
		   LPSTR lpCmd, int nCmdShow)
{
	TWGALApp WGALApp( "MineSolver", hInstance, hPrevInstance,
        lpCmd, nCmdShow);
    WGALApp.Run();
	return ( WGALApp.Status );
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
